/*
	A basic extension of the java.awt.Dialog class
 */

import java.awt.*;

public class HelpDialog extends Dialog {

	public HelpDialog(Frame parent, boolean modal)
	{
		super(parent, modal);

		// This code is automatically generated by Visual Cafe when you add
		// components to the visual environment. It instantiates and initializes
		// the components. To modify the code, only use code syntax that matches
		// what Visual Cafe can generate, or Visual Cafe may be unable to back
		// parse your Java file into its visual environment.

		//{{INIT_CONTROLS
		GridBagLayout gridBagLayout;
		gridBagLayout = new GridBagLayout();
		setLayout(gridBagLayout);
		setVisible(false);
		setSize(400,350);
		setBackground(new Color(12632256));
		okButton = new java.awt.Button();
		okButton.setLabel("OK");
		okButton.setBounds(737,430,71,23);
		GridBagConstraints gbc;
		gbc = new GridBagConstraints();
		gbc.gridx = 0;
		gbc.gridy = 1;
		gbc.anchor = GridBagConstraints.EAST;
		gbc.fill = GridBagConstraints.NONE;
		gbc.insets = new Insets(10,10,10,10);
		gbc.ipadx = 40;
		((GridBagLayout)getLayout()).setConstraints(okButton, gbc);
		add(okButton);
		textArea1 = new java.awt.TextArea("",0,0,TextArea.SCROLLBARS_VERTICAL_ONLY);
		textArea1.setEditable(false);
		textArea1.setBounds(10,10,798,400);
		gbc = new GridBagConstraints();
		gbc.gridx = 0;
		gbc.gridy = 0;
		gbc.weightx = 1.0;
		gbc.weighty = 1.0;
		gbc.fill = GridBagConstraints.BOTH;
		gbc.insets = new Insets(10,10,10,10);
		((GridBagLayout)getLayout()).setConstraints(textArea1, gbc);
		add(textArea1);
		cheatCheckBox = new java.awt.Checkbox("Cheating Enabled");
		cheatCheckBox.setBounds(10,430,129,23);
		gbc = new GridBagConstraints();
		gbc.gridx = 0;
		gbc.gridy = 1;
		gbc.anchor = GridBagConstraints.WEST;
		gbc.fill = GridBagConstraints.NONE;
		gbc.insets = new Insets(10,10,10,10);
		((GridBagLayout)getLayout()).setConstraints(cheatCheckBox, gbc);
		add(cheatCheckBox);
		setTitle("Help");
		//}}
		String text = SolEditor.EDITORVERSION
		    + "\n\nI'm not going to say too much about the help. "
		    + "The only thing that might lead to confusion is "
		    + "how to select some of the different tiles, so "
		    + "here is a brief summary.\n\n"
		    + "Regular mouse click:\n"
		    + "Selects different tiles that are similar to the "
		    + "one shown. For static tiles, this will usually "
		    + "put them where they are hidden behind a block.\n"
		    + "For this reason, the block with nothing behind it seems kind of hidden. "
		    + "To use this block, you select the empty tile button "
		    + "and click on an empty tile in the level map.\n"
		    + "For enemy tiles, it will change their orientation.\n"
		    + "For the spark enemy, it will also change its speed, F for fast "
		    + "and S for slow.\n\n"
            + "Any other mouse click (2nd or 3rd mouse button or "
            + "holding down a meta key while clicking):\n"
            + "Clears the current tile an places an empty tile.\n\n"
            + "Another thing to note, if you want to save your levels so "
            + "they can be modified later, you must save them as a .dat (data) "
            + "file. An .85s file cannot be opened by the editor.\n\n"
            + "Cheating can also be enabled for a level. This was created for level "
            + "designers so they could easily get to the next level. Cheating is enabled "
            + "by checking the check box below. While playing a level on the calculator, "
            + "the MORE key will now instantly go to the next level. This value is reset "
            + "every time the editor is restarted.\n";
        textArea1.setText(text);
        cheatCheckBox.setState( SolEditor.isCheatingEnabled );
        
		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();
		okButton.addActionListener(lSymAction);
		//}}

	}

	public HelpDialog(Frame parent, String title, boolean modal)
	{
		this(parent, modal);
		setTitle(title);
	}

	public void addNotify()
	{
		// Record the size of the window prior to calling parents addNotify.
                Dimension d = getSize();

		super.addNotify();

		// Only do this once.
		if (fComponentsAdjusted)
			return;

		// Adjust components according to the insets
		setSize(insets().left + insets().right + d.width, insets().top + insets().bottom + d.height);
		Component components[] = getComponents();
		for (int i = 0; i < components.length; i++)
		{
			Point p = components[i].getLocation();
			p.translate(insets().left, insets().top);
			components[i].setLocation(p);
		}

		// Used for addNotify check.
		fComponentsAdjusted = true;
	}

	public void setVisible(boolean b)
	{
	    if (b)
	    {
    		Rectangle bounds = getParent().bounds();
    		Rectangle abounds = bounds();

    		move(bounds.x + (bounds.width - abounds.width)/ 2,
    			 bounds.y + (bounds.height - abounds.height)/2);
	    }

		super.setVisible(b);
	}

	//{{DECLARE_CONTROLS
	java.awt.Button okButton;
	java.awt.TextArea textArea1;
	java.awt.Checkbox cheatCheckBox;
	//}}

        // Used for addNotify check.
	boolean fComponentsAdjusted = false;

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == HelpDialog.this)
				AboutDialog_WindowClosing();
		}
	}

	void AboutDialog_WindowClosing()
	{
        SolEditor.isCheatingEnabled = cheatCheckBox.getState();

        dispose();
	}

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == okButton)
				okButton_Clicked(event);
		}
	}

	void okButton_Clicked(java.awt.event.ActionEvent event)
	{
        AboutDialog_WindowClosing();
	}
}
