/*
	This simple extension of the java.awt.Frame class
	contains all the elements necessary to act as the
	main window of an application.
 */

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.Vector;

public class SolEditor extends Frame
{
    final static String EDITORVERSION = "Solomon's Key Level Editor v1.0";
    final static String DATVERSION = "Sol's Key Data File v1.0";

    static SolTile empty1 = null;
    static SolTile empty2 = null;
    static SolTile hourglass1 = null;
    static SolTile hourglass2 = null;
    static SolTile wall1 = null;
    static SolTile timebottle1 = null;
    static SolTile timebottle2 = null;
    static SolTile fireballbottle1 = null;
    static SolTile fireballbottle2 = null;
    static SolTile scroll1 = null;
    static SolTile scroll2 = null;
    static SolTile window1 = null;
    static SolTile window2 = null;
    static SolTile closeddoor1 = null;
    static SolTile key1 = null;
    static SolTile key2 = null;
    static SolTile solomon1 = null;
    static SolTile spark1 = null;
    static SolTile spark2 = null;
    static SolTile spark3 = null;
    static SolTile spark4 = null;
    static SolTile flame1 = null;
    static SolTile skull1 = null;
    static SolTile spitter1 = null;
    static SolTile spitter2 = null;
    static SolTile spitter3 = null;
    static SolTile spitter4 = null;

    public static SolTile[] solTiles = null;

    SolTile[] solButtonTiles = null;
    
    ImageButton[] solButtons = null;

    public static final int IMAGEWIDTH          = 32;
    public static final int IMAGEHEIGHT         = 32;
    public static final int IMAGEBUTTONWIDTH    = 40;
    public static final int IMAGEBUTTONHEIGHT   = 40;
    public static final int LEVELROWS           = 7;
    public static final int LEVELCOLS           = 16;
    public static final int LEVELSIZE           = LEVELROWS * LEVELCOLS;

    public static final int MAXENEMIES          = 14;
    public static final int MAXTITLELENGTH      = 20;
    // bit 6 set for all enemies and sol
    public static final byte CHARMASK           = (byte)0x40; 
    // high 2 bits not looked at for static tiles
    public static final byte BLOCKMASK          = (byte)0x3F;

    public static boolean isCheatingEnabled     = false;

    SolButtonListener solButtonL = null;
    int buttonPressed = 0;                  // index into button array
    SolTile currentTile = null;             // Tile to be added on a mouse click
    SolLevel currentLevel = null;
    Vector solLevels = null;
	
	public SolEditor(String title)
	{
		this();
		setTitle(title);
	}
	
	public SolEditor()
	{
		// This code is automatically generated by Visual Cafe when you add
		// components to the visual environment. It instantiates and initializes
		// the components. To modify the code, only use code syntax that matches
		// what Visual Cafe can generate, or Visual Cafe may be unable to back
		// parse your Java file into its visual environment.
		//{{INIT_CONTROLS
		GridBagLayout gridBagLayout;
		gridBagLayout = new GridBagLayout();
		setLayout(gridBagLayout);
		setVisible(false);
		setSize(640,400);
		setForeground(new Color(0));
		setBackground(new Color(12632256));
		levelChoice = new java.awt.Choice();
		levelChoice.setBounds(10,227,202,21);
		GridBagConstraints gbc;
		gbc = new GridBagConstraints();
		gbc.gridx = 0;
		gbc.gridy = 4;
		gbc.weightx = 1.0;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.insets = new Insets(0,10,10,10);
		((GridBagLayout)getLayout()).setConstraints(levelChoice, gbc);
		add(levelChoice);
		titleTextField = new java.awt.TextField();
		titleTextField.setText("Level Title Here");
		titleTextField.setBounds(232,226,190,23);
		gbc = new GridBagConstraints();
		gbc.gridx = 1;
		gbc.gridy = 4;
		gbc.weightx = 1.0;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.insets = new Insets(0,10,10,10);
		((GridBagLayout)getLayout()).setConstraints(titleTextField, gbc);
		add(titleTextField);
		nameTextField = new java.awt.TextField();
		nameTextField.setText("Your Name Here");
		nameTextField.setBounds(560,258,247,23);
		gbc = new GridBagConstraints();
		gbc.gridx = 2;
		gbc.gridy = 4;
		gbc.weightx = 1.0;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.insets = new Insets(0,10,10,10);
		((GridBagLayout)getLayout()).setConstraints(nameTextField, gbc);
		add(nameTextField);
		levelLabel = new java.awt.Label("Level",Label.CENTER);
		levelLabel.setBounds(0,235,281,23);
		levelLabel.setForeground(new Color(0));
		gbc = new GridBagConstraints();
		gbc.gridx = 0;
		gbc.gridy = 3;
		gbc.weightx = 1.0;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.insets = new Insets(0,0,0,0);
		((GridBagLayout)getLayout()).setConstraints(levelLabel, gbc);
		add(levelLabel);
		titleLabel = new java.awt.Label("Level Title",Label.CENTER);
		titleLabel.setBounds(281,235,269,23);
		titleLabel.setForeground(new Color(0));
		gbc = new GridBagConstraints();
		gbc.gridx = 1;
		gbc.gridy = 3;
		gbc.weightx = 1.0;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.insets = new Insets(0,0,0,0);
		((GridBagLayout)getLayout()).setConstraints(titleLabel, gbc);
		add(titleLabel);
		nameLabel = new java.awt.Label("Name",Label.CENTER);
		nameLabel.setBounds(550,235,267,23);
		nameLabel.setForeground(new Color(0));
		gbc = new GridBagConstraints();
		gbc.gridx = 2;
		gbc.gridy = 3;
		gbc.weightx = 1.0;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.insets = new Insets(0,0,0,0);
		((GridBagLayout)getLayout()).setConstraints(nameLabel, gbc);
		add(nameLabel);
		tileButtonsPanel = new java.awt.Panel();
		tileButtonsPanel.setLayout(new FlowLayout(FlowLayout.CENTER,5,5));
		tileButtonsPanel.setBounds(403,182,10,10);
		gbc = new GridBagConstraints();
		gbc.gridx = 0;
		gbc.gridy = 1;
		gbc.gridwidth = 3;
		gbc.fill = GridBagConstraints.NONE;
		gbc.insets = new Insets(0,0,0,0);
		((GridBagLayout)getLayout()).setConstraints(tileButtonsPanel, gbc);
		add(tileButtonsPanel);
		levelCanvasPanel = new java.awt.Panel();
		levelCanvasPanel.setLayout(null);
		levelCanvasPanel.setBounds(403,172,10,10);
		gbc = new GridBagConstraints();
		gbc.gridx = 0;
		gbc.gridy = 0;
		gbc.gridwidth = 3;
		gbc.fill = GridBagConstraints.NONE;
		gbc.insets = new Insets(0,0,0,0);
		((GridBagLayout)getLayout()).setConstraints(levelCanvasPanel, gbc);
		add(levelCanvasPanel);
		addBeforeButton = new java.awt.Button();
		addBeforeButton.setLabel("Add Level Before");
		addBeforeButton.setBounds(30,202,221,23);
		addBeforeButton.setBackground(new Color(12632256));
		gbc = new GridBagConstraints();
		gbc.gridx = 0;
		gbc.gridy = 2;
		gbc.weightx = 1.0;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.insets = new Insets(10,30,10,30);
		((GridBagLayout)getLayout()).setConstraints(addBeforeButton, gbc);
		add(addBeforeButton);
		addAfterButton = new java.awt.Button();
		addAfterButton.setLabel("Add Level After");
		addAfterButton.setBounds(311,202,209,23);
		addAfterButton.setBackground(new Color(12632256));
		gbc = new GridBagConstraints();
		gbc.gridx = 1;
		gbc.gridy = 2;
		gbc.weightx = 1.0;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.insets = new Insets(10,30,10,30);
		((GridBagLayout)getLayout()).setConstraints(addAfterButton, gbc);
		add(addAfterButton);
		removeButton = new java.awt.Button();
		removeButton.setLabel("Remove Level");
		removeButton.setBounds(580,202,207,23);
		removeButton.setBackground(new Color(12632256));
		gbc = new GridBagConstraints();
		gbc.gridx = 2;
		gbc.gridy = 2;
		gbc.weightx = 1.0;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.insets = new Insets(10,30,10,30);
		((GridBagLayout)getLayout()).setConstraints(removeButton, gbc);
		add(removeButton);
		setTitle("Solomon's Key Level Editor");
		//}}
		
		//{{INIT_MENUS
		mainMenuBar = new java.awt.MenuBar();
		menu1 = new java.awt.Menu("File");
		miOpenDAT = new java.awt.MenuItem("Open DAT...");
		menu1.add(miOpenDAT);
		miSaveAsDAT = new java.awt.MenuItem("Save As DAT...");
		menu1.add(miSaveAsDAT);
		miSaveAs85S = new java.awt.MenuItem("Save As 85S...");
		menu1.add(miSaveAs85S);
		menu1.addSeparator();
		miExit = new java.awt.MenuItem("Exit");
		menu1.add(miExit);
		mainMenuBar.add(menu1);
		menu3 = new java.awt.Menu("Help");
		mainMenuBar.setHelpMenu(menu3);
		miAbout = new java.awt.MenuItem("About..");
		menu3.add(miAbout);
		miHelp = new java.awt.MenuItem("Help..");
		menu3.add(miHelp);
		mainMenuBar.add(menu3);
		setMenuBar(mainMenuBar);
		//$$ mainMenuBar.move(24,384);
		//}}
		
		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();
		miOpenDAT.addActionListener(lSymAction);
		miAbout.addActionListener(lSymAction);
		miHelp.addActionListener(lSymAction);
		miExit.addActionListener(lSymAction);
		addBeforeButton.addActionListener(lSymAction);
		addAfterButton.addActionListener(lSymAction);
		removeButton.addActionListener(lSymAction);
		SymItem lSymItem = new SymItem();
		levelChoice.addItemListener(lSymItem);
		miSaveAsDAT.addActionListener(lSymAction);
		miSaveAs85S.addActionListener(lSymAction);
		//}}
		
		myInitialization();
	}
	
	public void myInitialization()
	{
	    java.net.URL url = getClass().getResource( "solicon.gif" );
        Image icon = getToolkit().getImage( url );
        setIconImage( icon );

        // instantiate all of the tiles
        empty1 = new SolTile(0x00, "empty1");
        empty2 = new SolTile(0x80, "empty2");
        hourglass1 = new SolTile(0x01, "hourglass1");
        hourglass2 = new SolTile(0x81, "hourglass2");
        wall1 = new SolTile(0x82, "wall1");
        timebottle1 = new SolTile(0x03, "timebottle1");
        timebottle2 = new SolTile(0x83, "timebottle2");
        fireballbottle1 = new SolTile(0x04, "fireballbottle1");
        fireballbottle2 = new SolTile(0x84, "fireballbottle2");
        scroll1 = new SolTile(0x05, "scroll1");
        scroll2 = new SolTile(0x85, "scroll2");
        window1 = new SolTile(0x06, "window1");
        window2 = new SolTile(0x86, "window2");
        closeddoor1 = new SolTile(0x07, "closeddoor1");
        key1 = new SolTile(0x08, "key1");
        key2 = new SolTile(0x88, "key2");
        solomon1 = new SolTile(0x40, "solomon1");
        spark1 = new SolTile(0x41, "spark1");      // fast spark (TL)
        spark2 = new SolTile(0x42, "spark2");      // slow spark (TL)
        spark3 = new SolTile(0x43, "spark3");      // change fast spark (BR)
        spark4 = new SolTile(0x44, "spark4");      // change slow spark (BR)
        flame1 = new SolTile(0x45, "flame1");
        skull1 = new SolTile(0x46, "skull1");
        spitter1 = new SolTile(0x48, "spitter1");
        spitter2 = new SolTile(0x49, "spitter2");
        spitter3 = new SolTile(0x4A, "spitter3");
        spitter4 = new SolTile(0x4B, "spitter4");

        // each SolTile needs to be linked to the other tiles in the same group
        empty1.setNext(empty2);
        empty2.setNext(empty1);
        hourglass1.setNext(hourglass2);
        hourglass2.setNext(hourglass1);
        wall1.setNext(wall1);
        timebottle1.setNext(timebottle2);
        timebottle2.setNext(timebottle1);
        fireballbottle1.setNext(fireballbottle2);
        fireballbottle2.setNext(fireballbottle1);
        scroll1.setNext(scroll2);
        scroll2.setNext(scroll1);
        window1.setNext(window2);
        window2.setNext(window1);
        closeddoor1.setNext(closeddoor1);
        key1.setNext(key2);
        key2.setNext(key1);
        solomon1.setNext(solomon1);
        spark1.setNext(spark2);
        spark2.setNext(spark3);
        spark3.setNext(spark4);
        spark4.setNext(spark1);
        flame1.setNext(flame1);
        skull1.setNext(skull1);
        spitter1.setNext(spitter4);
        spitter2.setNext(spitter3);
        spitter3.setNext(spitter1);
        spitter4.setNext(spitter2);

        // initialize array of tiles
        solTiles = new SolTile[27];
        solTiles[0] = empty1;
        solTiles[1] = empty2;
        solTiles[2] = hourglass1;
        solTiles[3] = hourglass2;
        solTiles[4] = wall1;
        solTiles[5] = timebottle1;
        solTiles[6] = timebottle2;
        solTiles[7] = fireballbottle1;
        solTiles[8] = fireballbottle2;
        solTiles[9] = scroll1;
        solTiles[10] = scroll2;
        solTiles[11] = window1;
        solTiles[12] = window2;
        solTiles[13] = closeddoor1;
        solTiles[14] = key1;
        solTiles[15] = key2;
        solTiles[16] = solomon1;
        solTiles[17] = spark1;
        solTiles[18] = spark2;
        solTiles[19] = spark3;
        solTiles[20] = spark4;
        solTiles[21] = flame1;
        solTiles[22] = skull1;
        solTiles[23] = spitter1;
        solTiles[24] = spitter2;
        solTiles[25] = spitter3;
        solTiles[26] = spitter4;

        solButtonTiles = new SolTile[14];
        solButtonTiles[0] = empty1;
        solButtonTiles[1] = hourglass1;
        solButtonTiles[2] = wall1;
        solButtonTiles[3] = timebottle1;
        solButtonTiles[4] = fireballbottle1;
        solButtonTiles[5] = scroll1;
        solButtonTiles[6] = window1;
        solButtonTiles[7] = closeddoor1;
        solButtonTiles[8] = key1;
        solButtonTiles[9] = solomon1;
        solButtonTiles[10] = spark1;
        solButtonTiles[11] = flame1;
        solButtonTiles[12] = skull1;
        solButtonTiles[13] = spitter1;

        // create new button for each different type of tile
        solButtons = new ImageButton[solButtonTiles.length];
        solButtonL = new SolButtonListener();

        for (int i=0; i<solButtons.length; i++)
        {
            solButtons[i] = new ImageButton( solButtonTiles[i].getImage(),
                                             IMAGEBUTTONWIDTH,
                                             IMAGEBUTTONHEIGHT,
                                             IMAGEWIDTH,
                                             IMAGEHEIGHT );
            solButtons[i].addActionListener( solButtonL );
            tileButtonsPanel.add( solButtons[i] );
        };

        buttonPressed = 0;
        currentTile = solButtonTiles[buttonPressed];
        solButtons[buttonPressed].setPressed( true );

        currentLevel = new SolLevel( this );
        levelCanvasPanel.setSize(currentLevel.getSize());
        levelCanvasPanel.add( currentLevel );

        solLevels = new Vector(5);
        solLevels.addElement( currentLevel );
        
        updateLevelChoice(0);
        
        invalidate();
        validate();
    }
	
    private class SolButtonListener implements ActionListener
    {
        public void actionPerformed( ActionEvent e )
        {
            int i;

            // current button no longer pressed
            solButtons[buttonPressed].setPressed( false );

            for (i=0; i<solButtons.length; i++)
            {
                if ( e.getSource() == solButtons[i] )
                    break;
            }

            buttonPressed = i;
            currentTile = solButtonTiles[i];
            solButtons[buttonPressed].setPressed( true );
        }
    }
    
    
    /**
     * Shows or hides the component depending on the boolean flag b.
     * @param b  if true, show the component; otherwise, hide the component.
     * @see java.awt.Component#isVisible
     */
    public void setVisible(boolean b)
	{
		if(b)
		{
			setLocation(50, 50);
		}
		super.setVisible(b);
	}

	public static void main(String args[])
	{
		(new SolEditor()).setVisible(true);
	}
	
	public void addNotify()
	{
		// Record the size of the window prior to calling parents addNotify.
		Dimension d = getSize();
		
		super.addNotify();
	
		if (fComponentsAdjusted)
			return;
	
		// Adjust components according to the insets
		setSize(insets().left + insets().right + d.width, insets().top + insets().bottom + d.height);
		Component components[] = getComponents();
		for (int i = 0; i < components.length; i++)
		{
			Point p = components[i].getLocation();
			p.translate(insets().left, insets().top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}
	
	// Used for addNotify check.
	boolean fComponentsAdjusted = false;
	
	//{{DECLARE_CONTROLS
	java.awt.Choice levelChoice;
	java.awt.TextField titleTextField;
	java.awt.TextField nameTextField;
	java.awt.Label levelLabel;
	java.awt.Label titleLabel;
	java.awt.Label nameLabel;
	java.awt.Panel tileButtonsPanel;
	java.awt.Panel levelCanvasPanel;
	java.awt.Button addBeforeButton;
	java.awt.Button addAfterButton;
	java.awt.Button removeButton;
	//}}
	
	//{{DECLARE_MENUS
	java.awt.MenuBar mainMenuBar;
	java.awt.Menu menu1;
	java.awt.MenuItem miOpenDAT;
	java.awt.MenuItem miSaveAsDAT;
	java.awt.MenuItem miSaveAs85S;
	java.awt.MenuItem miExit;
	java.awt.Menu menu3;
	java.awt.MenuItem miAbout;
	java.awt.MenuItem miHelp;
	//}}
	
	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == SolEditor.this)
				Frame1_WindowClosing(event);
		}
	}
	
	void Frame1_WindowClosing(java.awt.event.WindowEvent event)
	{
	    exitProgram();
	}
	
	void exitProgram()
	{
		setVisible(false);	// hide the Frame
		dispose();			// free the system resources
		System.exit(0);		// close the application
    }
	
	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == miOpenDAT)
				miOpenDAT_Action(event);
			else if (object == miAbout)
				miAbout_Action(event);
			else if (object == miHelp)
				miHelp_Action(event);
			else if (object == miExit)
				miExit_Action(event);
			else if (object == addBeforeButton)
				addBeforeButton_ActionPerformed(event);
			else if (object == addAfterButton)
				addAfterButton_ActionPerformed(event);
			else if (object == removeButton)
				removeButton_ActionPerformed(event);
			else if (object == miSaveAsDAT)
				miSaveAsDAT_ActionPerformed(event);
			else if (object == miSaveAs85S)
				miSaveAs85S_ActionPerformed(event);
		}
	}
	
	void miAbout_Action(java.awt.event.ActionEvent event)
	{
		//{{CONNECTION
		// Action from About Create and show as modal
		(new AboutDialog(this, true)).setVisible(true);
		//}}
	}
	
	void miHelp_Action(java.awt.event.ActionEvent event)
	{
		//{{CONNECTION
		(new HelpDialog(this, true)).setVisible(true);
		//}}
	}
	
	void miExit_Action(java.awt.event.ActionEvent event)
	{
        exitProgram();
	}
	
	void addBeforeButton_ActionPerformed(java.awt.event.ActionEvent event)
	{
	    if ( ! isLevelValid(
	        levelChoice.getSelectedIndex(), 
	        currentLevel.getLevelBytes() ) )
	    {
	        // don't add a new level
	        return;
	    }
	    
	    int index = levelChoice.getSelectedIndex();

	    solLevels.insertElementAt(new SolLevel(this), index);
	    
        // update the level choice control and set the current level
        updateLevelChoice(index);
	}

	void addAfterButton_ActionPerformed(java.awt.event.ActionEvent event)
	{
	    if ( ! isLevelValid(
	        levelChoice.getSelectedIndex(), 
	        currentLevel.getLevelBytes() ) )
	    {
	        // don't add a new level
	        return;
	    }

	    int index = levelChoice.getSelectedIndex();

	    solLevels.insertElementAt(new SolLevel(this), index+1);
	    
        // update the level choice control and set the current level
        updateLevelChoice(index+1);
	}

	void removeButton_ActionPerformed(java.awt.event.ActionEvent event)
	{
	    // make sure there is a level to remove
        if ( (solLevels == null) || (solLevels.size() == 0) )
        {
            return;
        }
	    
	    // are we removing the only level?
	    if (solLevels.size() == 1)
	    {
	        // remove the last level
	        solLevels.removeElementAt( 0 );

	        // now insert a new empty level
	        solLevels.insertElementAt( new SolLevel(this), 0 );

            // update the level choice control and set the current level
	        updateLevelChoice(0);
	    }
        // remove the level currently selected
        else
        {
    	    int index = levelChoice.getSelectedIndex();
    	    int count = levelChoice.getItemCount();

            // remove this level from solLevels
            solLevels.removeElementAt(index);

            // if the index is last element, decrease to point at new last index
            index = ((count-1) == index) ? index-1 : index ;

            // update the level choice control and set the current level
	        updateLevelChoice(index);
        }
	}
	
	void updateLevelChoice(int selIndex)
	{
	    levelChoice.removeAll();

	    if (solLevels == null)
	    {
	        return;
	    }
	    
	    for (int i=0; i< solLevels.size(); i++)
	    {
            levelChoice.add("Level " + (i+1));
        }
        
        try
        {
            levelChoice.select(selIndex);
    	    levelChoice_ItemStateChanged(null);
        }
        catch (IllegalArgumentException e)
        {
        }
	    
	}

	class SymItem implements java.awt.event.ItemListener
	{
		public void itemStateChanged(java.awt.event.ItemEvent event)
		{
			Object object = event.getSource();
			if (object == levelChoice)
				levelChoice_ItemStateChanged(event);
		}
	}

	void levelChoice_ItemStateChanged(java.awt.event.ItemEvent event)
	{
	    levelCanvasPanel.remove(currentLevel);
	    
	    // get the index of the current level
	    int index = levelChoice.getSelectedIndex();

        // this is the new current level
	    currentLevel = ((SolLevel)solLevels.elementAt(index));

        levelCanvasPanel.add(currentLevel);
        levelCanvasPanel.invalidate(); 
        levelCanvasPanel.validate();
	}

	void miOpenDAT_Action(java.awt.event.ActionEvent event)
	{
		FileDialog fd = new java.awt.FileDialog(this);
		fd.setMode(FileDialog.LOAD);
		fd.setTitle("Open DAT");
		fd.setDirectory( System.getProperty("user.dir") );
		fd.setFile("*.dat");

		fd.setVisible(true);
		
		if ( fd.getFile() == null )
		    return;
		
		try
		{
		    FileInputStream s = new FileInputStream( fd.getDirectory() +
		                                             fd.getFile() );

            byte[] inData = null;
            
            // read the version string
            inData = new byte[DATVERSION.length()];
            s.read(inData);
            for (int i=0; i<inData.length; i++)
            {
                // if all of the bytes aren't the same, don't read this file
                if (inData[i] != DATVERSION.getBytes()[i])
                    return;
            }
            
            // read the level title
            inData = new byte[s.read()];
            s.read(inData);
            String title = new String( inData );

            // write the author name
            inData = new byte[s.read()];
            s.read(inData);
            String name = new String( inData );
            
            // write the number of levels
            byte[][] levelData = new byte[s.read()][LEVELSIZE];
            for (int i=0; i<levelData.length; i++)
            {
                s.read(levelData[i]);
            }

            // file terminated with a 0xFF
            int tmp = s.read();

            if ( tmp != 0xFF )
                return;

            // we now have all of the data we need for the level
            // so start putting in the GUI
            titleTextField.setText( title );
            nameTextField.setText( name );
            solLevels = getLevelsVector( levelData );

    	    updateLevelChoice(0);
		}
		catch (Exception e)
		{
		}
	}

	void miSaveAsDAT_ActionPerformed(java.awt.event.ActionEvent event)
	{
		FileDialog fd = new java.awt.FileDialog(this);
		fd.setMode(FileDialog.SAVE);
		fd.setTitle("Save As DAT");
		fd.setDirectory( System.getProperty("user.dir") );
		fd.setFile("*.dat");

		fd.setVisible(true);

		if ( fd.getFile() == null )
		    return;

		try
		{
		    String filename = fd.getDirectory() + fd.getFile();
		    
		    if ( ! filename.toLowerCase().endsWith(".dat") )
		    {
		        filename += ".dat";
		    }
		    
		    FileOutputStream s = new FileOutputStream( filename );

            byte[][] levelData = getSolLevelByteArrays();
            
            // write the version string
            s.write(DATVERSION.getBytes());
            
            // write the level title
            s.write((byte)titleTextField.getText().length());
            s.write(titleTextField.getText().getBytes());
            
            // write the author name
            s.write((byte)nameTextField.getText().length());
            s.write(nameTextField.getText().getBytes());
            
            // write the number of levels followed by LEVELSIZE*number bytes for the levels
            s.write((byte)levelData.length);
            for (int i=0; i<levelData.length; i++)
            {
                s.write(levelData[i]);
            }

            // write FF to terminate the file
            s.write((byte)0xFF);
		}
		catch (Exception e)
		{
		}
	}

	void miSaveAs85S_ActionPerformed(java.awt.event.ActionEvent event)
	{
	    if ( ! isAllLevelsValid() )
	    {
	        // return without saving
	        return;
	    }
	    
	    if ( titleTextField.getText().length() > MAXTITLELENGTH )
	    {
	        String text = "Title can be no more than "
	            + MAXTITLELENGTH
	            + " characters long.";
	        (new MessageDialog(this,true,text)).setVisible(true);

	        // return without saving
	        return;
	    }
	    
		FileDialog fd = new java.awt.FileDialog(this);
		fd.setMode(FileDialog.SAVE);
		fd.setTitle("Save As 85S");
		fd.setDirectory( System.getProperty("user.dir") );
		fd.setFile("*.85s");

		fd.setVisible(true);

		if ( fd.getFile() == null )
		    return;

		try
		{
		    String filename = fd.getDirectory() + fd.getFile();

		    if ( (! filename.toLowerCase().endsWith(".85g")) &&
		         (! filename.toLowerCase().endsWith(".85s")) &&
		         (! filename.toLowerCase().endsWith(".86g")) &&
		         (! filename.toLowerCase().endsWith(".86s")) )
		    {
		        filename += ".85s";
		    }

            SolTI85String str = new SolTI85String( filename,
                                                   nameTextField.getText(),
                                                   titleTextField.getText(),
                                                   getSolLevelsBytes()
                                                 );
        }
        catch (Exception e)
        {
        }
	}
	
	byte[][] getSolLevelByteArrays()
	{
	    byte[][] a = new byte[solLevels.size()][];
	    
	    for (int i=0; i<solLevels.size(); i++)
	    {
	        a[i] = ((SolLevel)solLevels.elementAt(i)).getLevelBytes();
	    }

	    return a;
	}

    Vector getLevelsVector( byte[][] levelData )
    {
        Vector v = new Vector(levelData.length);
        
        for (int i=0; i<levelData.length; i++)
        {
            SolTile[][] l = getSolLevelTiles( levelData[i] );
            v.insertElementAt( new SolLevel(l,this), i );
        }
        
        return v;
    }
    
    byte[][] getSolLevelsBytes()
    {
        byte[][] array = new byte[solLevels.size()][LEVELSIZE];
        
        for (int i=0; i<array.length; i++)
        {
            array[i] = ((SolLevel)solLevels.elementAt(i)).getLevelBytes();
        }
        
        return array;
    }

    SolTile[][] getSolLevelTiles( byte[] level )
    {
        SolTile[][] l = new SolTile[LEVELROWS][LEVELCOLS];
        
        for (int i=0; i<level.length; i++)
        {
            l[i/LEVELCOLS][i%LEVELCOLS] = getTile( level[i] );
        }
        
        return l;
    }
    
    SolTile getTile( byte tileValue )
    {
        for (int i=0; i<solTiles.length; i++)
        {
            if ( tileValue == solTiles[i].getValue() )
                return solTiles[i];
        }
        
        // didn't find value specified so return first tile in array
        return solTiles[0];
    }

    private boolean isLevelValid(int levelIndex, byte[] level)
    {
        int enemyCount = 0;
        int solCount = 0;
        int keyCount = 0;
        int doorCount = 0;

        for (int i=0; i<level.length; i++)
        {
            // is it an enemy or sol tile
            if ( (level[i] & CHARMASK) != 0 )
            {
                // is it a solomon tile?
                if ( level[i] == solomon1.getValue() )
                {
                    solCount++;
                }
                else
                {
                    enemyCount++;
                }
            }
            else if ( (level[i] & BLOCKMASK) == key1.getValue() ) 
            {
                keyCount++;
            }
            else if ( (level[i] & BLOCKMASK) == closeddoor1.getValue() ) 
            {
                doorCount++;
            }
        }
        
        int numErrors = 0;
        String errorMessage = "";
        
        if ( solCount != 1  )
        {
            numErrors++;
            errorMessage += "Error " + numErrors + ":\n"
                + "Exactly 1 Solomon character must be used for each level."
                + "\n\n";
        }
        if ( enemyCount > MAXENEMIES )
        {
            numErrors++;
            errorMessage += "Error " + numErrors + ":\n"
                + "Maximum enemies for a single level is "
                + MAXENEMIES
                + "."
                + "\n\n";
        }
        if ( keyCount != 1  )
        {
            numErrors++;
            errorMessage += "Error " + numErrors + ":\n"
                + "Exactly 1 Key tile must be used for each level."
                + "\n\n";
        }
        if ( doorCount != 1  )
        {
            numErrors++;
            errorMessage += "Error " + numErrors + ":\n"
                + "Exactly 1 Door tile must be used for each level."
                + "\n\n";
        }
        
        if ( numErrors > 0 )
        {
            errorMessage = "LEVEL " + (levelIndex + 1) + "\n\n"
                + numErrors 
                + " errors have occurred while creating this level. "
                + "These must be corrected before "
                + "the level can be successfully generated.\n\n"
                + errorMessage;

            (new MessageDialog(this, false, errorMessage)).setVisible(true);
            
            return false;
        }
        
        return true;
    }

    private boolean isAllLevelsValid()
    {
        boolean allValid = true;
        byte [][] levels = getSolLevelsBytes();
        
        for (int i=0; i<levels.length; i++)
        {
	        if ( ! isLevelValid(i, levels[i]) )
    	    {
    	        allValid = false;
    	    }
    	}
    	
    	return allValid;
    }

}

