import java.awt.Component;
import java.awt.Image;
import java.awt.Graphics;
import java.io.File;

public class SolTile extends Component
{
    private byte tileValue = 0;
    private String name = null;
    private Image image = null;
    private SolTile next = null;

    public SolTile(int tileValue, String name)
    {
        this((byte)tileValue, name);
    }

    public SolTile(byte tileValue, String name)
    {
        this.tileValue = tileValue;

        this.name = name;

        java.net.URL url = getClass().getResource( name + ".gif" );

        image = getToolkit().getImage( url );
    }

    public Image getImage()
    {
        return image;
    }

    public byte getValue()
    {
        return tileValue;
    }
    
    public SolTile getNext()
    {
        return next;
    }
    
    public void setNext(SolTile next)
    {
        this.next = next;
    }
    
    public java.awt.Dimension getSize()
    {
        return new java.awt.Dimension( image.getWidth(this), 
                                       image.getHeight(this) );
    }

    // returns true if tile is in the linked list of this tile
    public boolean isSameTileType( SolTile tile )
    {
        SolTile tmpTile = tile;
        
        // loop through all of the tiles for thie type of tile
        do 
        {
            tmpTile = tmpTile.getNext();

            // is it the same type as the tile we are trying to place?
            if ( tmpTile == this )
            {
                return true;
            }
        }
        while ( tmpTile != tile );

        return false;
    }
    
    public String toString()
    {
        return name;
    }
}
